'############################################################################################

'                 -delta peak Lader fr 1x - 2x NiMh Akkus mit Attiny13
'                              Schaltschwelle bei ~5mV
'         Ladestrom/Zelle je nach Vorwiderstand (25mA/h - 2,5Ah) "NiCd Loader.dsn"
'
'                              FUSE im Auslieferstatus

'PINB.0 = PNP Schalttransistor
'PINB.1 = LED grn gegen GND, Ladeende
'PINB.2 = LED rot gegen GND. Laden
'PINB.3 = ADC Eingang
'PINB.4 = LED gelb gegen GND, 30 Min. keine entscheidende Spannungsnderung

'############################################################################################


                               'Angaben fr den Kompiler
                               '------------------------

'Prozessor
$regfile = "attiny13.dat"

'Takt, intern 1,2 MHz
$crystal = 1200000

'Speicherreservierung
$hwstack = 10
$swstack = 15
$framesize = 10

'Konfiguration Variable
Dim A As Bit
Dim B As Bit
Dim T As Byte
Dim Batterie1 As Word
Dim Batsav1 As Word
Dim Zaehler1 As Byte
Dim Zaehler2 As Word

'conf Port's B auf Eingabe=0, Ausgabe=1
Ddrb = &B0001_0111

'conf Port's B auf 0 oder 1
Portb = &B0000_0000

'conf Pin's B auf 0 oder 1 (PullUp Widerstnde)
Pinb = &B0000_0000

'Konfiguration ADC (Referenz = Versorgungsspannung)
Config Adc = Single , Prescaler = Auto , Reference = Avcc

'voreingestellte Schalterwerte
B = 1
T = 5
Batterie1 = Getadc(3)



                       'Schleife des Ladeprogramm
                       '=========================

Do

'Portumschaltung, LED rot, bei Ladeende LED grn ON
     Portb.0 = A
     Portb.1 = A
     Portb.2 = B
     If A = 1 Then T = 150
     If A = 1 Then Zaehler1 = 0
     If A = 1 Then Zaehler2 = 0

'Ladeperiode
     Wait 3

'Portumschaltung fr Messpause
     Portb.0 = B
     Portb.1 = B
     Portb.2 = A

'Messpause
     Waitms T

'Abfrage neuer Spannungswert
     Batterie1 = Getadc(3)

'Entscheidung: -delta peak ja (Ladeende ca. 60 Sekunden)
     If Batterie1 < Batsav1 Then Zaehler1 = Zaehler1 + 1
     If Batterie1 => Batsav1 Then Zaehler1 = 0
     If Zaehler1 = 20 Then A = 1

'Entscheidung: wenn keine Spannungsnderung dann Timeout (Ladeende ca.30 Minuten) LED gelb ON
     If Batterie1 = Batsav1 Then Zaehler2 = Zaehler2 + 1
     If Batterie1 <> Batsav1 Then Zaehler2 = 0
     If Zaehler2 = 600 Then A = 1
     If Zaehler2 = 600 Then Portb.4 = 1
     If A = 1 Then B = 0

'Neuen Spannungswert speichern
     If Batterie1 > Batsav1 Then Batsav1 = Batterie1


Loop